//画面填充模式
enum TX_Enum_Type_RenderMode{
  ///< 图像铺满屏幕，不留黑边，如果图像宽高比不同于屏幕宽高比，部分画面内容会被裁剪掉。
  FILL_SCREEN,
  ///< 图像适应屏幕，保持画面完整，但如果图像宽高比不同于屏幕宽高比，会有黑边的存在。
  FILL_EDGE
}

enum TX_Enum_Type_HomeOrientation{
  RIGHT,
  DOWN,
  LEFT,
  UP
}

enum TX_Enum_PlayType {
    /// RTMP 直播
    PLAY_TYPE_LIVE_RTMP,
    /// FLV 直播
    PLAY_TYPE_LIVE_FLV,
    /// FLV 点播
    PLAY_TYPE_VOD_FLV,
    /// HLS 点播
    PLAY_TYPE_VOD_HLS,
    /// MP4点播
    PLAY_TYPE_VOD_MP4,
    /// RTMP 直播加速播放
    PLAY_TYPE_LIVE_RTMP_ACC,
    /// 本地视频文件
    PLAY_TYPE_LOCAL_VIDEO,
}


const int VIDEO_RESOLUTION_TYPE_360_640 = 0;

const int VIDEO_RESOLUTION_TYPE_540_960 = 1;

const int VIDEO_RESOLUTION_TYPE_720_1280 = 2;

const int VIDEO_RESOLUTION_TYPE_640_360 = 3;

const int VIDEO_RESOLUTION_TYPE_960_540 = 4;

const int VIDEO_RESOLUTION_TYPE_1280_720 = 5;

const int VIDEO_RESOLUTION_TYPE_320_480 = 6;

const int VIDEO_RESOLUTION_TYPE_180_320 = 7;

const int VIDEO_RESOLUTION_TYPE_270_480 = 8;

const int VIDEO_RESOLUTION_TYPE_320_180 = 9;

const int VIDEO_RESOLUTION_TYPE_480_270 = 10;

const int VIDEO_RESOLUTION_TYPE_240_320 = 11;

const int VIDEO_RESOLUTION_TYPE_360_480 = 12;

const int VIDEO_RESOLUTION_TYPE_480_640 = 13;

const int VIDEO_RESOLUTION_TYPE_320_240 = 14;

const int VIDEO_RESOLUTION_TYPE_480_360 = 15;

const int VIDEO_RESOLUTION_TYPE_640_480 = 16;

const int VIDEO_RESOLUTION_TYPE_480_480 = 17;

const int VIDEO_RESOLUTION_TYPE_270_270 = 18;

const int VIDEO_RESOLUTION_TYPE_160_160 = 19;

const int VIDEO_RESOLUTION_TYPE_1080_1920 = 30;

const int VIDEO_RESOLUTION_TYPE_1920_1080 = 31;

const int VIDEO_QUALITY_STANDARD_DEFINITION = 1;

const int VIDEO_QUALITY_HIGH_DEFINITION = 2;

const int VIDEO_QUALITY_SUPER_DEFINITION = 3;

const int VIDEO_QUALITY_LINKMIC_MAIN_PUBLISHER = 4;

const int VIDEO_QUALITY_LINKMIC_SUB_PUBLISHER = 5;

const int VIDEO_QUALITY_REALTIEM_VIDEOCHAT = 6;

const int VIDEO_QUALITY_ULTRA_DEFINITION = 7;

const int VIDEO_ANGLE_HOME_RIGHT = 0;

const int VIDEO_ANGLE_HOME_DOWN = 1;

const int VIDEO_ANGLE_HOME_LEFT = 2;

const int VIDEO_ANGLE_HOME_UP = 3;

const int CUSTOM_MODE_AUDIO_CAPTURE = 1;

const int CUSTOM_MODE_VIDEO_CAPTURE = 2;

const int CUSTOM_MODE_AUDIO_PREPROCESS = 4;

const int CUSTOM_MODE_VIDEO_PREPROCESS = 8;

const int RENDER_MODE_FULL_FILL_SCREEN = 0;

const int RENDER_MODE_ADJUST_RESOLUTION = 1;

const int RENDER_ROTATION_PORTRAIT = 0;

const int RENDER_ROTATION_LANDSCAPE = 270;

const int RENDER_ROTATION_0 = 0;

const int RENDER_ROTATION_90 = 90;

const int RENDER_ROTATION_180 = 180;

const int RENDER_ROTATION_270 = 270;

const int LOCAL_VIDEO_MIRROR_TYPE_AUTO = 0;

const int LOCAL_VIDEO_MIRROR_TYPE_ENABLE = 1;

const int LOCAL_VIDEO_MIRROR_TYPE_DISABLE = 2;

const int AUTO_ADJUST_NONE = -1;

const int AUTO_ADJUST_LIVEPUSH_STRATEGY = 0;

const int AUTO_ADJUST_LIVEPUSH_RESOLUTION_STRATEGY = 1;

const int AUTO_ADJUST_REALTIME_VIDEOCHAT_STRATEGY = 5;

const int AUTO_ADJUST_BITRATE_STRATEGY_1 = 0;

const int AUTO_ADJUST_BITRATE_RESOLUTION_STRATEGY_1 = 1;

const int AUTO_ADJUST_BITRATE_STRATEGY_2 = 2;

const int AUTO_ADJUST_BITRATE_RESOLUTION_STRATEGY_2 = 3;

const int AUTO_ADJUST_REALTIME_BITRATE_STRATEGY = 4;

const int AUTO_ADJUST_REALTIME_BITRATE_RESOLUTION_STRATEGY = 5;

const int PUSH_EVT_CONNECT_SUCC = 1001;

const int PUSH_EVT_PUSH_BEGIN = 1002;

const int PUSH_EVT_OPEN_CAMERA_SUCC = 1003;

const int PUSH_EVT_SCREEN_CAPTURE_SUCC = 1004;

const int PUSH_EVT_CHANGE_RESOLUTION = 1005;

const int PUSH_EVT_CHANGE_BITRATE = 1006;

const int PUSH_EVT_FIRST_FRAME_AVAILABLE = 1007;

const int PUSH_EVT_START_VIDEO_ENCODER = 1008;

const int PUSH_EVT_ROOM_IN = 1018;

const int PUSH_EVT_ROOM_IN_FAILED = 1022;

const int PUSH_EVT_ROOM_OUT = 1019;

const int PUSH_EVT_ROOM_USERLIST = 1020;

const int PUSH_EVT_ROOM_NEED_REENTER = 1021;

const int PUSH_EVT_ROOM_USER_ENTER = 1031;

const int PUSH_EVT_ROOM_USER_EXIT = 1032;

const int PUSH_EVT_ROOM_USER_VIDEO_STATE = 1033;

const int PUSH_EVT_ROOM_USER_AUDIO_STATE = 1034;

const int PUSH_ERR_OPEN_CAMERA_FAIL = -1301;

const int PUSH_ERR_OPEN_MIC_FAIL = -1302;

const int PUSH_ERR_VIDEO_ENCODE_FAIL = -1303;

const int PUSH_ERR_AUDIO_ENCODE_FAIL = -1304;

const int PUSH_ERR_UNSUPPORTED_RESOLUTION = -1305;

const int PUSH_ERR_UNSUPPORTED_SAMPLERATE = -1306;

const int PUSH_ERR_NET_DISCONNECT = -1307;

const int PUSH_ERR_SCREEN_CAPTURE_START_FAILED = -1308;

const int PUSH_ERR_SCREEN_CAPTURE_UNSURPORT = -1309;

const int PUSH_ERR_SCREEN_CAPTURE_DISTURBED = -1310;

const int PUSH_ERR_MIC_RECORD_FAIL = -1311;

const int PUSH_ERR_SCREEN_CAPTURE_SWITCH_DISPLAY_FAILED = -1312;

const int PUSH_ERR_INVALID_ADDRESS = -1313;

const int PUSH_WARNING_NET_BUSY = 1101;

const int PUSH_WARNING_RECONNECT = 1102;

const int PUSH_WARNING_HW_ACCELERATION_FAIL = 1103;

const int PUSH_WARNING_VIDEO_ENCODE_FAIL = 1104;

const int PUSH_WARNING_BEAUTYSURFACE_VIEW_INIT_FAIL = 1105;

const int PUSH_WARNING_VIDEO_ENCODE_BITRATE_OVERFLOW = 1106;

const int PUSH_WARNING_VIDEO_ENCODE_SW_SWITCH_HW = 1107;

const int PUSH_WARNING_DNS_FAIL = 3001;

const int PUSH_WARNING_SEVER_CONN_FAIL = 3002;

const int PUSH_WARNING_SHAKE_FAIL = 3003;

const int PUSH_WARNING_SERVER_DISCONNECT = 3004;

const int PUSH_WARNING_READ_WRITE_FAIL = 3005;

const int PUSH_WARNING_VIDEO_RENDER_FAIL = 2110;

const int PLAY_EVT_CONNECT_SUCC = 2001;

const int PLAY_EVT_RTMP_STREAM_BEGIN = 2002;

const int PLAY_EVT_RCV_FIRST_I_FRAME = 2003;

const int PLAY_EVT_PLAY_BEGIN = 2004;

const int PLAY_EVT_PLAY_PROGRESS = 2005;

const int PLAY_EVT_PLAY_END = 2006;

const int PLAY_EVT_PLAY_LOADING = 2007;

const int PLAY_EVT_START_VIDEO_DECODER = 2008;

const int PLAY_EVT_CHANGE_RESOLUTION = 2009;

const int PLAY_EVT_GET_PLAYINFO_SUCC = 2010;

const int PLAY_EVT_CHANGE_ROTATION = 2011;

const int PLAY_EVT_GET_MESSAGE = 2012;

const int PLAY_EVT_VOD_PLAY_PREPARED = 2013;

const int PLAY_EVT_VOD_LOADING_END = 2014;

const int PLAY_EVT_STREAM_SWITCH_SUCC = 2015;

const int PLAY_EVT_GET_METADATA = 2028;

const int PLAY_EVT_GET_FLVSESSIONKEY = 2031;

const int PLAY_ERR_NET_DISCONNECT = -2301;

const int PLAY_ERR_GET_RTMP_ACC_URL_FAIL = -2302;

const int PLAY_ERR_FILE_NOT_FOUND = -2303;

const int PLAY_ERR_HEVC_DECODE_FAIL = -2304;

const int PLAY_ERR_HLS_KEY = -2305;

const int PLAY_ERR_GET_PLAYINFO_FAIL = -2306;

const int PLAY_ERR_STREAM_SWITCH_FAIL = -2307;

const int PLAY_WARNING_VIDEO_DECODE_FAIL = 2101;

const int PLAY_WARNING_AUDIO_DECODE_FAIL = 2102;

const int PLAY_WARNING_RECONNECT = 2103;

const int PLAY_WARNING_RECV_DATA_LAG = 2104;

const int PLAY_WARNING_VIDEO_PLAY_LAG = 2105;

const int PLAY_WARNING_HW_ACCELERATION_FAIL = 2106;

const int PLAY_WARNING_VIDEO_DISCONTINUITY = 2107;

const int PLAY_WARNING_FIRST_IDR_HW_DECODE_FAIL = 2108;

const int PLAY_WARNING_DNS_FAIL = 3001;

const int PLAY_WARNING_SEVER_CONN_FAIL = 3002;

const int PLAY_WARNING_SHAKE_FAIL = 3003;

const int PLAY_WARNING_READ_WRITE_FAIL = 3005;

const int LOG_LEVEL_VERBOSE = 0;

const int LOG_LEVEL_DEBUG = 1;

const int LOG_LEVEL_INFO = 2;

const int LOG_LEVEL_WARN = 3;

const int LOG_LEVEL_ERROR = 4;

const int LOG_LEVEL_FATAL = 5;

const int LOG_LEVEL_NULL = 6;

const String EVT_TIME = "EVT_TIME";

const String EVT_DESCRIPTION = "EVT_MSG";

const String EVT_PARAM1 = "EVT_PARAM1";

const String EVT_PARAM2 = "EVT_PARAM2";

const String EVT_GET_MSG = "EVT_GET_MSG";

const String EVT_PLAY_COVER_URL = "EVT_PLAY_COVER_URL";

const String EVT_PLAY_URL = "EVT_PLAY_URL";

const String EVT_PLAY_NAME = "EVT_PLAY_NAME";

const String EVT_PLAY_DESCRIPTION = "EVT_PLAY_DESCRIPTION";

const String EVT_PLAY_PROGRESS_MS = "EVT_PLAY_PROGRESS_MS";

const String EVT_PLAY_DURATION_MS = "EVT_PLAY_DURATION_MS";

const String EVT_PLAY_PROGRESS = "EVT_PLAY_PROGRESS";

const String EVT_PLAY_DURATION = "EVT_PLAY_DURATION";

const String EVT_PLAYABLE_DURATION_MS = "EVT_PLAYABLE_DURATION_MS";

const String NET_STATUS_CPU_USAGE = "CPU_USAGE";

const String NET_STATUS_VIDEO_WIDTH = "VIDEO_WIDTH";

const String NET_STATUS_VIDEO_HEIGHT = "VIDEO_HEIGHT";

const String NET_STATUS_VIDEO_FPS = "VIDEO_FPS";

const String NET_STATUS_VIDEO_GOP = "VIDEO_GOP";

const String NET_STATUS_VIDEO_BITRATE = "VIDEO_BITRATE";

const String NET_STATUS_AUDIO_BITRATE = "AUDIO_BITRATE";

const String NET_STATUS_NET_SPEED = "NET_SPEED";

const String NET_STATUS_AUDIO_CACHE = "AUDIO_CACHE";

const String NET_STATUS_VIDEO_CACHE = "VIDEO_CACHE";

const String NET_STATUS_AUDIO_DROP = "AUDIO_DROP";

const String NET_STATUS_VIDEO_DROP = "VIDEO_DROP";

const String NET_STATUS_V_SUM_CACHE_SIZE = "V_SUM_CACHE_SIZE";

const String NET_STATUS_V_DEC_CACHE_SIZE = "V_DEC_CACHE_SIZE";

const String NET_STATUS_AV_PLAY_INTERVAL = "AV_PLAY_INTERVAL";

const String NET_STATUS_AV_RECV_INTERVAL = "AV_RECV_INTERVAL";

const String NET_STATUS_AUDIO_CACHE_THRESHOLD = "AUDIO_CACHE_THRESHOLD";

const String NET_STATUS_AUDIO_INFO = "AUDIO_PLAY_INFO";

const String NET_STATUS_NET_JITTER = "NET_JITTER";

const String NET_STATUS_SERVER_IP = "SERVER_IP";

const String NET_STATUS_VIDEO_DPS = "VIDEO_DPS";

const String NET_STATUS_QUALITY_LEVEL = "NET_QUALITY_LEVEL";

const int PAUSE_FLAG_PAUSE_VIDEO = 1;

const int PAUSE_FLAG_PAUSE_AUDIO = 2;

const String TXRTMPSDK_PUSHEVENT_SOURCE_OPENCAMERA =
    "TXRTMPSDK_PUSHEVENT_SOURCE_OPENCAMERA";

const String TXRTMPSDK_PUSHEVENT_SOURCE_OPENMIC =
    "TXRTMPSDK_PUSHEVENT_SOURCE_OPENMIC";

const String TXRTMPSDK_VIDEO_YUVSOURCE_LOCALCAMERA =
    "TXRTMPSDK_VIDEO_YUVSOURCE_LOCALCAMERA";

const String TXRTMPSDK_AUDIO_PCMSOURCE_LOCALMERGER =
    "TXRTMPSDK_AUDIO_PCMSOURCE_LOCALMERGER";

const int REVERB_TYPE_0 = 0;

const int REVERB_TYPE_1 = 1;

const int REVERB_TYPE_2 = 2;

const int REVERB_TYPE_3 = 3;

const int REVERB_TYPE_4 = 4;

const int REVERB_TYPE_5 = 5;

const int REVERB_TYPE_6 = 6;

const int VOICECHANGER_TYPE_0 = 0;

const int VOICECHANGER_TYPE_1 = 1;

const int VOICECHANGER_TYPE_2 = 2;

const int VOICECHANGER_TYPE_3 = 3;

const int VOICECHANGER_TYPE_4 = 4;

const int VOICECHANGER_TYPE_5 = 5;

const int VOICECHANGER_TYPE_6 = 6;

const int VOICECHANGER_TYPE_7 = 7;

const int VOICECHANGER_TYPE_8 = 8;

const int VOICECHANGER_TYPE_9 = 9;

const int VOICECHANGER_TYPE_10 = 10;

const int VOICECHANGER_TYPE_11 = 11;

const int ENCODE_VIDEO_SOFTWARE = 0;

const int ENCODE_VIDEO_HARDWARE = 1;

const int ENCODE_VIDEO_AUTO = 2;

const int RTMP_CHANNEL_TYPE_AUTO = 0;

const int RTMP_CHANNEL_TYPE_STANDARD = 1;

const int RTMP_CHANNEL_TYPE_PRIVATE = 2;

const int BEAUTY_STYLE_SMOOTH = 0;

const int BEAUTY_STYLE_NATURE = 1;

const int BEAUTY_STYLE_PITU = 2;

const int BEAUTY_STYLE_HAZY = 3;

const int AUDIO_ROUTE_SPEAKER = 0;

const int AUDIO_ROUTE_RECEIVER = 1;

const int AUDIO_VOLUME_TYPE_AUTO = 0;

const int AUDIO_VOLUME_TYPE_MEDIA = 1;

const int AUDIO_VOLUME_TYPE_VOIP = 2;
